/* This program is used to test and to demonstrate
 * the features of CDB.  It tries to have a "little
 * of everything", so it doesn't make much sense.
 */

#include <stdio.h>
#include <signal.h>

typedef union {
	struct { int s11; } s1;
	struct { int s21, s22; } s2;
	struct { int s31, s32, s33; } s3;
	} U1U, *pU1U;
U1U	a_union;

struct foo {
	struct foo *fooNext;
	struct bar *pbar;  /* points at undefined struct */
	} afoo;

typedef struct foo *pFOOR;

typedef enum COLOR {red, orange, yellow,
		green=10, blue, purple} COLORE;
COLORE	colore;

typedef struct RECS {
	short	a;
	char	b[9];
	long	c;
	unsigned bits1 : 1;
	unsigned bits2 : 2;
	unsigned bits3 : 3;
	unsigned bits4 : 4;
	COLORE	color : 5;
	int	(*prtn)();
	} RECR, *pRECR;

extern int main();
extern int First();
extern char * Second();
extern int Third();

struct RECS a_record = {-1, "Apple Pi",
	987654321L, 1, 2, 4, 8, purple,main};

struct RECS record_array[] = {
	{0, "First",	 0L, 0, 0, 0, 0, red, First},
	{1, "Second",	-1L, 1, 1, 1, 1, orange, main},
	{2, "Third",	-2L, 1, 2, 2, 2, yellow, Third},
	{3, "Fourth",	-3L, 1, 3, 3, 3, green, main},
	{4, "Fifth",	-4L, 1, 1, 4, 4, blue, main},
	{5, "Sixth",	-5L, 1, 2, 5, 5, purple, First},
	};

char	*string_array[5] = { "0", "1", "2", "3", "4" };
char	himom[15] = "Hi there, Mom!";
char	char_array[2][5]= {
			00, 01, 02, 03, 04,
			10, 11, 12, 13, 14,
			};
int	int_array[4][7]= {
			00, 01, 02, 03, 04, 05, 06,
			10, 11, 12, 13, 14, 15, 16,
			20, 21, 22, 23, 24, 25, 26,
			30, 31, 32, 33, 34, 35, 36
			};
char	dbl_array[10][128] = {"0","1","2","3","4","5","6","7","8","9"};
int	loop, seconds, recurse;


/* A L A R M I S T */

Alarmist()
{
    signal(SIGALRM, Alarmist);
    alarm(seconds);
} /* Alarmist /* 


/* M A I N */

int main(argc, argv, envp)
int	argc;
char	*argv[];
char	*envp[];
{
    int		recurseLevel, cMainArgs, i, fUsedArg;
    char	*sbArg, *sbTemp, *sbUsage;

    sbUsage = "Usage: loe [-s #] [-r #]\n";
    cMainArgs = 0;

    for (i = 1; i < argc; ++i) {
	sbArg = argv[i];
	if (*sbArg != '-') {

	    printf(sbUsage);
	    exit(1);

	} else {

	    /* this is an option string */
	    ++sbArg;	/* move past the '-' */
	    while (*sbArg) {
		/* point to a potential argument */
		sbTemp = (sbArg[1] != '\0') ? sbArg+1 : argv[i+1];
		fUsedArg = 0; /* set to true if option uses an arguement */

		switch (*sbArg) {
		    default:
			printf(sbUsage);
			exit(1);
		    
		    case 'r':
			recurseLevel = atoi(sbTemp);
			fUsedArg = 1;
			break;

		    case 's':
			seconds = atoi(sbTemp);
			fUsedArg = 1;
			break;

		} /* switch */
		++sbArg;
		if (fUsedArg) {
		    if (*sbArg == '\0')
			i++;	/* eat next word - it was the arg we used */
		    *sbArg = '\0';
		} /* if */
	    } /* while */
	} /* if */
    } /* for all command line arguments */

    /* Main code */
    if (seconds != 0)
	alarm(seconds);

    string_array[0] = "a";
    string_array[1] = "b";
    string_array[2] = "c";

    while (*argv)
	printf("%s\n",*(argv++));

    for (loop=1; loop != 0; loop++) {
	recurse = recurseLevel;
	First(loop, loop, loop);
    } /* for */

    printf("done\n");
    exit(0);
} /* main */


/* S E C O N D */

char * Second(aaa, bbb, ccc)
register char	aaa;
register short ccc;
int	bbb;
{
    long	x;

    if (recurse) {
	--recurse;
	Second(aaa+recurse+1, bbb+recurse+1, ccc+recurse+1);
	return((char *)recurse);
    } /* if */

    x = aaa + bbb + ccc;
    Third(aaa, -1, "A good message", &a_record);
    return((char *) 0);
} /* Second */


/* T H I R D */

Third(select, random, message, rec)
register long	 select;
int	random;
register char	*message;
pRECR	rec;
{
    register float	fl;
    double	xfl;
    static struct RECS *precord;

    precord = rec;
    xfl = fl = 5.8;

    if (select != 0) {
	int random;

	random = -9;
	switch (select % 7) {
	    case 1:	printf("1\n");	break;
	    case 2:	printf("2\n");	break;
	    case 3:	printf("3\n");	break;
	    case 4:	printf("4\n");	break;
	    default:	printf("default\n");	break;
	} /* switch */
    } /* if */

    printf("%s\n", message);
} /* Third */


/* F I R S T */

First(i, j, k)
int	i;
char	j;
short	k;
{
    Second(i, j+1, k+2);
} /* First */


/* A D D   A R G S */

static double AddArgs(i, d)
int	i, d;
{
    int		value;

    value = i + d;
    Second(i, i+1, i+2);
    return(value * 3.2);
} /* AddArgs */


/* _ R E C S */

static void _RECS(rec, x)
struct RECS *rec;
int	x;
{
    if (x != -1)
	fprintf(stderr, "x == %d\n", x);
    fprintf(stderr,"a = %d, b = %s, c = %d\n",
		rec->a, rec->b, rec->c);
    fprintf(stderr,"bits = %d %d %d %d, color = %d\n",
	rec->bits1, rec->bits2, rec->bits3,
	rec->bits4, rec->color);
    fflush(stderr);
} /* _RECS */
